"""
Expect a picture every 10 ticks.
Keep the most recent sentence, and add it in a word at a time every
50 ticks.
"""
class spikeQueue:

    def __init__(self):
        print "new q"
        self.ticksSent = 0
        self.endOfTick = [0xFFFFFFFF]
        #self.fileOut = open ("cabot2Pipe","wb")

        #
        self.currentSentenceLeft = 0
        self.currentPosInSent = 0
        self.sendWordTick = 0

    def terminate(self):
        self.fileOut.close()

    def writeFourByteWord(self,word):
        lowByte = word%256
        word = word/256
        twoByte = word%256
        word = word/256
        threeByte = word%256
        highByte = word/256
        byteArray = bytearray([lowByte,twoByte,threeByte,highByte])
        #sys.stdout.write(byteArray)
        self.fileOut.write(byteArray)

    def writeTicks(self,numBlanks):
        self.fileOut = open ("cabot2Pipe","wb")
        for i in range (0,numBlanks):
            self.ticksSent = self.ticksSent + 1
            if (self.ticksSent >= (self.sendWordTick + 50)):
                    self.sendWord()
                
            self.writeFourByteWord(self.endOfTick[0])
        self.fileOut.close()

    def writePicture(self,wordArray,length):
        self.fileOut = open ("cabot2Pipe","wb")
        for i in range (0,length):
            self.writeFourByteWord(wordArray[i])
        self.fileOut.close()

    def sendWord(self):
        self.sendWordTick = self.ticksSent
        if self.currentSentenceLeft == 0:
            return
        self.writeFourByteWord(self.currentSentence[self.currentPosInSent])
        print self.currentSentence[self.currentPosInSent]
        self.currentPosInSent += 1
        self.currentSentenceLeft -= 1

    def writeSentence(self,sentence,length):
        print sentence
        if self.currentSentenceLeft == 0:
            self.currentPosInSent = 0
            self.currentSentenceLeft = length
            self.currentSentence = sentence
        else:
            print "trying to parse new sentence while parsing"

    def oldwriteSentence(self,sentence,length):
        self.fileOut = open ("cabot2Pipe","wb")
        self.writeTicks(57)
        for i in range (0,length):
            self.writeFourByteWord(sentence[i])
            self.writeTicks(49)
        self.fileOut.close()

    def addConditionalTicks(self,numBlanks):
        self.writeTicks(numBlanks)
