from nealParams import *

def addNewConn(pre,post,weight):
    if (pre >= 0) and (pre <  neuronsPerSubnet):
        return [(pre,post,weight,DELAY)]
    else:
        return []

def getHEdgeBottomFrom3x3OffExcite():
    weight = 3.0
    connectors = []
    for inpNeuron in range (0,neuronsPerSubnet):
        col = inpNeuron % INPSIZE
        if (col > 0):
            newConn = addNewConn(inpNeuron-1,inpNeuron,weight)
            connectors = connectors + newConn
        if (col > 1):
            newConn = addNewConn(inpNeuron-2,inpNeuron,weight)
            connectors = connectors + newConn
        connectors = connectors + [(inpNeuron,inpNeuron,weight,DELAY)]
        if (col < (INPSIZE-1)):
            newConn = addNewConn(inpNeuron+1,inpNeuron,weight)
            connectors = connectors + newConn
        if (col < (INPSIZE-2)):
            newConn = addNewConn(inpNeuron+2,inpNeuron,weight)
            connectors = connectors + newConn

    return connectors

def getHEdgeBottomFrom9x9OffInhib():
    weight = -3.0
    connectors = []
    for inpNeuron in range (0,neuronsPerSubnet):
        col = inpNeuron % INPSIZE
        if (col > 3): 
            newConn = addNewConn(inpNeuron-(2*INPSIZE)-4,inpNeuron,weight)
            connectors = connectors + newConn
        if (col > 2): 
            newConn = addNewConn(inpNeuron-(2*INPSIZE)-3,inpNeuron,weight)
            connectors = connectors + newConn
        if (col > 1):
            newConn = addNewConn(inpNeuron-(2*INPSIZE)-2,inpNeuron,weight)
            connectors = connectors + newConn
        if (col > 0):
            newConn = addNewConn(inpNeuron-(2*INPSIZE)-1,inpNeuron,weight)
            connectors = connectors + newConn
        newConn = addNewConn(inpNeuron-(2*INPSIZE),inpNeuron,weight)
        connectors = connectors + newConn 
        if (col < (INPSIZE-1)):
            newConn = addNewConn(inpNeuron-(2*INPSIZE)+1,inpNeuron,weight)
            connectors = connectors + newConn
        if (col < (INPSIZE-2)):
            newConn = addNewConn(inpNeuron-(2*INPSIZE)+2,inpNeuron,weight)
            connectors = connectors + newConn
        if (col < (INPSIZE-3)):
            newConn = addNewConn(inpNeuron-(2*INPSIZE)+3,inpNeuron,weight)
            connectors = connectors + newConn
        if (col < (INPSIZE-4)):
            newConn = addNewConn(inpNeuron-(2*INPSIZE)+4,inpNeuron,weight)
            connectors = connectors + newConn

    return connectors

def getHEdgeTopFrom3x3OffExcite():
    weight = 3.0
    connectors = []
    for inpNeuron in range (0,neuronsPerSubnet):
        col = inpNeuron % INPSIZE
        if (col > 0):
            newConn = addNewConn(inpNeuron-1,inpNeuron,weight)
            connectors = connectors + newConn
        if (col > 1):
            newConn = addNewConn(inpNeuron-2,inpNeuron,weight)
            connectors = connectors + newConn
        connectors = connectors + [(inpNeuron,inpNeuron,weight,DELAY)]
        if (col < (INPSIZE-1)):
            newConn = addNewConn(inpNeuron+1,inpNeuron,weight)
            connectors = connectors + newConn
        if (col < (INPSIZE-2)):
            newConn = addNewConn(inpNeuron+2,inpNeuron,weight)
            connectors = connectors + newConn

    return connectors

def getHEdgeTopFrom9x9OffInhib():
    weight = -3.0
    connectors = []
    for inpNeuron in range (0,neuronsPerSubnet):
        col = inpNeuron % INPSIZE
        if (col > 3):
            newConn = addNewConn(inpNeuron-4,inpNeuron,weight)
            connectors = connectors + newConn
        if (col > 2):
            newConn = addNewConn(inpNeuron-3,inpNeuron,weight)
            connectors = connectors + newConn
        if (col > 1):
            newConn = addNewConn(inpNeuron-2,inpNeuron,weight)
            connectors = connectors + newConn
        if (col > 0):
            newConn = addNewConn(inpNeuron-1,inpNeuron,weight)
            connectors = connectors + newConn
        connectors = connectors + [(inpNeuron,inpNeuron,weight,DELAY)]
        if (col < (INPSIZE-1)):
            newConn = addNewConn(inpNeuron+1,inpNeuron,weight)
            connectors = connectors + newConn
        if (col < (INPSIZE-2)):
            newConn = addNewConn(inpNeuron+2,inpNeuron,weight)
            connectors = connectors + newConn
        if (col < (INPSIZE-3)):
            newConn = addNewConn(inpNeuron+3,inpNeuron,weight)
            connectors = connectors + newConn
        if (col < (INPSIZE-4)):
            newConn = addNewConn(inpNeuron+4,inpNeuron,weight)
            connectors = connectors + newConn

    return connectors
